<?php

namespace App\Commands;

use CodeIgniter\CLI\BaseCommand;
use CodeIgniter\CLI\CLI;
use Config\Clients;
use Config\Database;
use App\Models\VentasModel;
use App\Libraries\FacturacionElectronica;

class EnviarDTEs extends BaseCommand
{
    protected $group       = 'DET Manager';
    protected $name        = 'enviardtes';
    protected $description = 'Genera y envía los DTE legible y json que han sido procesados correctamente';
    protected $arguments   = ['isc' => 'Identificador del sistema de cliente'];
    protected $options     = ['--cant' => 'Cantidad maxima de DTE a tomar de la cola.'];

    
    public function run(array $params)
    {
        $isc = $params[0] ?? null;
        $cantDte = CLI::getOption('cant') ?? 5;

        if ($isc) {
            $client = new Clients();
            $dbgroup = $client->getDBGroup($isc);
            if ($dbgroup) 
            {
                $database = new Database();
                $dbConf = $database->getDatabaseConfig($dbgroup);
                $db = \Config\Database::connect($dbConf);

                $systemVersion = $client->getSystem($isc);
                $feStartDate = $client->getFeStartDate($isc);

                $ventasModel = new VentasModel($systemVersion, $db);

                $pendingSales = $ventasModel->getPendingSales($feStartDate, $cantDte);

                CLI::write(date('Y-m-d H:i:s').' '.$isc.' Ventas pendiente encontradas: ' . count($pendingSales));

                if($pendingSales){
                    CLI::write(date('Y-m-d H:i:s').' Iniciando consultas de DTEs');
                    $feEnv = $client->getFeEnv($isc);
                    $facturacionElectronica = new FacturacionElectronica($feEnv);

                    foreach ($pendingSales as $sale) {
                        CLI::write(date('Y-m-d H:i:s').' '.$isc.' Consultando dte: ' . $sale['dteCodGeneracion']);
                        //consultar DTE en API
                        $dte = $facturacionElectronica->consultarDTE($sale['dteCodGeneracion']);
                        if($dte)
                        {
                            $dteJson = isset($dte['json']) ? $dte['json'] : null;
                            if($dteJson)
                            {
                                $dteEstado = $dte['estado'];
                                $color = 'white';
                                switch($dteEstado){
                                    case 'PROCESADO':    $color = 'green'; break;
                                    case 'EN_PROCESO':   $color = 'yellow'; break;
                                    case 'FALLIDO':  	$color = 'red'; break;
                                }
                                CLI::write($dteEstado, $color);
                                //actualizar estado
                                $updated = false;
                                if($dteEstado == 'PROCESADO' || $dteEstado == 'FALLIDO'){
                                    //actualizar estado
                                    //$updated = $ventasModel->setDTEState($sale['id'], $dteEstado);
                                    $dteSello = isset($dte['recepcionHaciendaResponse']['selloRecibido']) ? $dte['recepcionHaciendaResponse']['selloRecibido'] : null;
                                    $dteFhProcesado = isset($dte['recepcionHaciendaResponse']['fhProcesamiento']) ? $dte['recepcionHaciendaResponse']['fhProcesamiento'] : null;
                                    if($dteFhProcesado){
                                        $dteFhProcesado = \DateTime::createFromFormat('d/m/Y H:i:s', $dteFhProcesado);
                                        $dteFhProcesado = $dteFhProcesado->format("Y-m-d H:i:s");
                                    }
                                    $dteError = isset($dte['error']) ? $dte['error'] : null;

                                    $updated = $ventasModel->setDTEInfo($sale['id'], $dteEstado, $dteSello, $dteFhProcesado, $dteError);
                                }
                                if($updated)
                                {
                                    CLI::write('ESTADO ACTUALIZADO', 'green');
                                    if($dteEstado == 'PROCESADO')
                                    {
                                        CLI::write(date('Y-m-d H:i:s').' Iniciando envio de correo electronico');
                                        $dteCorreo = isset($dteJson['receptor']['correo']) ? $dteJson['receptor']['correo'] : '';
                                        $correoEstado = "";
                                        $mailSend = false;
                                        if( $dteCorreo != null && $dteCorreo != ''){
                                            if(filter_var($dteCorreo, FILTER_VALIDATE_EMAIL)){
                                                $dteCorreo = strtolower($dteCorreo);

                                                $mailSender = $facturacionElectronica->enviarDTE(
                                                    $dte, 
                                                    $dteCorreo,
                                                    $client->getOutbound($isc),
                                                    [
                                                        'logo' => $client->getLogo($isc),
                                                        'comercial' => $client->getComercial($isc),
                                                        'nombre' => $client->getNombre($isc),
                                                        'telefono' => $client->getTelefono($isc),
                                                        'correo' => $client->getCorreo($isc)
                                                   ]
                                                );

                                                if($mailSender['send']){
                                                    CLI::write('Correo enviado a: ' . $dteCorreo, 'green');
                                                    $mailSend = true;
                                                    $correoEstado = "Correo enviado a: " . $dteCorreo;
                                                }
                                                else{
                                                    CLI::error('Error al enviar correo: ' . $mailSender['msg']);
                                                    $correoEstado = "Error al enviar correo: " . $mailSender['msg'];
                                                } 
                                            }
                                            else{
                                                CLI::error('Correo del receptor invalido');
                                                $correoEstado = "Dir. Correo no valida";
                                            }
                                        }
                                        else{
                                            CLI::error('Dir. Correo no disponible');
                                            $correoEstado = "Dir. Correo no disponible";
                                        }
                                        $mailInfoUpdate = $ventasModel->setEmailInfo($sale['id'], $mailSend, $correoEstado);
                                    }
                                }
                                else
                                {
                                    CLI::error('No se pudo actualizar el estado del DTE: ' . $sale['dteNControl']);
                                }
                            }
                            else
                            {
                                CLI::error('DTE ' . $sale['dteNControl'] . ' no tiene formato esperado: [\'json\'] no presente');
                            }
                        }
                        else
                        {
                            CLI::error('No se pudo obtener el DTE: ' . $sale['dteNControl']);
                        }
                        
                    }
                }
                else
                {
                    CLI::write('No se encontraron ventas pendientes');
                }
            }
            else 
            {
                $isc = CLI::error('Identificador del sistema de cliente invalido');
            }
        }
        else
        {
            $isc = CLI::error('Identificador del sistema de cliente invalido');
        }
    }
}